;###############################################################################
/* CommonMenu for LilBuilder

*/
;###############################################################################

CommonMenu_AddCommonItems(Menu_ID, CtrlType){
  If (CtrlType <> "StatusBar"){
    MMenu_Add(Menu_ID , "Anchor Control","","","iCommonMenu_AnchorControl")
    MMenu_Add(Menu_ID)
  }
}

CommonMenu_UpdateMenu(Menu_ID){
  CtrlHWND := Menu_vCtrlHWND()
  AnchorValue := Control(CtrlHWND,"AnchorValue")
  AnchoredCtrls := Gui(Menu_vGuiHWND(), "_AnchoredCtrls")
  IsAnchored := InStr(AnchoredCtrls,CtrlHWND)
  CheckStatus := IsAnchored ? "+c" : "-c"
  Text := (IsAnchored ? "Change Anchor" : "Anchor Control")
       .  (AnchorValue ? ": " AnchorValue : "")
  MMenu_Set(Menu_ID,1, Text,"", CheckStatus)
}

CommonMenu_AnchorControl:
  CommonMenu_AnchorControl(Menu_vGuiHWND(),Menu_vCtrlHWND())
Return
CommonMenu_AnchorControl(GuiHWND, ListOfCtrlHWND){
  AnchoredCtrls := Gui(GuiHWND, "_AnchoredCtrls")
  If InStr(ListOfCtrlHWND,"|"){
    AnchorValue = xy
  }Else {
    AnchorValue := Control(ListOfCtrlHWND,"AnchorValue")
    If !AnchorValue
      AnchorValue = xy
  }

  InputBox, NewAnchorValue, Set Anchor for Controls, Specify an anchor expression.`nNothing will remove any anchor, , , , Menu_vX(), Menu_vY(), , , %AnchorValue%
  If NewAnchorValue {
    Loop, Parse, ListOfCtrlHWND, |
      {
        If ("StatusBar" = Control(A_LoopField,"Type"))
          Continue
        Control(A_LoopField,"AnchorValue", NewAnchorValue)
        If !InStr(AnchoredCtrls,A_LoopField)
            AnchoredCtrls .= "|" A_LoopField
      }
  }Else{
    AnchoredCtrls = |%AnchoredCtrls%|
    Loop, Parse, ListOfCtrlHWND, |
      {
        CtrlHWND = |%A_LoopField%|
        StringReplace, AnchoredCtrls, AnchoredCtrls, %CtrlHWND%, |
      }
  }
  If (InStr(AnchoredCtrls,"|") = 1)
    StringTrimLeft, AnchoredCtrls, AnchoredCtrls, 1
  If (InStr(AnchoredCtrls,"|","",0) = StrLen(AnchoredCtrls))
    StringTrimRight, AnchoredCtrls, AnchoredCtrls, 1
  Gui(GuiHWND, "_AnchoredCtrls", AnchoredCtrls, AnchoredCtrls ? "" : "Clear")
}
