;###############################################################################
/* Menu for LilBuilder

*/
;###############################################################################

;create all menus ans fill them
Menu_Create() {
  local StandardCtrls                                 ;global context

  Menu_Toolbox := MMenu_Create()                      ;create special menus
  Menu_ToolboxShowGuis := MMenu_Create()
  Menu_ToolboxDeleteGuis := MMenu_Create()
  Toolbox_CreateMenu(Menu_Toolbox, Menu_ToolboxShowGuis, Menu_ToolboxDeleteGuis)

  Menu_Gui := MMenu_Create()
  Gui_CreateMenu(Menu_Gui)

  Menu_MultiSelection := MMenu_Create()
  MMenu_Add(Menu_MultiSelection , "Anchor Controls","","","iCommonMenu_AnchorControl")
  MMenu_Add(Menu_MultiSelection)
  MultiSelection_CreateMenu(Menu_MultiSelection)

  ;create menus for standard controls
  StandardCtrls := ToolBox_StandardCtrls()
  Loop, Parse, StandardCtrls, `,
  {
    Menu_%A_LoopField% := MMenu_Create()
    CommonMenu_AddCommonItems(Menu_%A_LoopField%, A_LoopField)  ;add common menu items
  }

  ;Tabpage Submenu
  Menu_TabPages := MMenu_Create()

  ;populate menus for standard controls
  Text_CreateMenu(Menu_Text)
  Edit_CreateMenu(Menu_Edit)
  ComboBox_CreateMenu(Menu_ComboBox)
  Button_CreateMenu(Menu_Button)
  CheckBox_CreateMenu(Menu_CheckBox)
  Radio_CreateMenu(Menu_Radio)
  Picture_CreateMenu(Menu_Picture)
  ListBox_CreateMenu(Menu_ListBox)
  ListView_CreateMenu(Menu_ListView)
  TreeView_CreateMenu(Menu_TreeView)
  Tab_CreateMenu(Menu_Tab, Menu_TabPages)
  HotKey_CreateMenu(Menu_HotKey)
  GroupBox_CreateMenu(Menu_GroupBox)
  DateTime_CreateMenu(Menu_DateTime)
  MonthCal_CreateMenu(Menu_MonthCal)
  Progress_CreateMenu(Menu_Progress)
  UpDown_CreateMenu(Menu_UpDown)
  Slider_CreateMenu(Menu_Slider)
  StatusBar_CreateMenu(Menu_StatusBar)
}

Menu_vCtrlHWND(NewHWND=""){         ;HWND of control for menu
  static HWND
  If NewHWND = No
     HWND =
  Else If NewHWND
     HWND = %NewHWND%
  Else Return %HWND%
}

Menu_vGuiHWND(NewHWND=""){          ;HWND of gui for menu
  static HWND
  If NewHWND = No
     HWND =
  Else If NewHWND
     HWND = %NewHWND%
  Else Return %HWND%
}

Menu_vX(NewX=""){                   ;global X position of menu
  static X
  If NewX = No
     X =
  Else If NewX
     X = %NewX%
  Else Return %X%
}

Menu_vY(NewY=""){                   ;global y position of menu
  static Y
  If NewY = No
     Y =
  Else If NewY
     Y = %NewY%
  Else Return %Y%
}
